/*!
 * KoliBri - The accessible HTML-Standard
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const index=require("./index-277fc2a7.js"),events=require("./events-221fcb43.js"),dev_utils=require("./dev.utils-0390f767.js"),controller=require("./controller-1840e05f.js"),associated_controller=require("./associated.controller-6ef4fe6e.js"),componentNames=require("./component-names-4a2d0b57.js"),prop_validators=require("./prop.validators-9c1f1dbd.js"),accessKey=require("./access-key-dda2764c.js"),ariaExpanded=require("./aria-expanded-9cc5b0f8.js"),icons=require("./icons-dc98cea7.js"),reuse=require("./reuse-50a5792c.js"),customClass=require("./custom-class-691f9ea4.js"),disabled=require("./disabled-523f7adc.js"),hideLabel=require("./hide-label-82890fe7.js"),label=require("./label-5e56f4a8.js"),tabIndex=require("./tab-index-a50181fc.js"),tooltipAlign=require("./tooltip-align-8c5c5618.js");require("./dev.utils-58fde089.js"),require("./index-6912b26b.js"),require("./common-1ab929ac.js"),require("./align-83af4905.js");const validateAriaControls=(t,e)=>{prop_validators.watchString(t,"_ariaControls",e)},validateAriaSelected=(t,e)=>{prop_validators.watchBoolean(t,"_ariaSelected",e)},validateButtonCallbacks=(t,e)=>{prop_validators.watchValidator(t,"_on",(t=>"object"==typeof t&&null!==t),new Set(["ButtonCallbacksPropType {Events.onClick, Events.onMouseDown}"]),e)},buttonTypePropTypeOptions=["button","reset","submit"],validateButtonType=(t,e)=>{prop_validators.watchValidator(t,"_type",(t=>"string"==typeof t&&buttonTypePropTypeOptions.includes(t)),new Set([`KoliBriButtonType {${buttonTypePropTypeOptions.join(", ")}`]),e)},buttonVariantPropTypeOptions=["primary","secondary","normal","tertiary","danger","ghost","custom"],validateButtonVariant=(t,e)=>{prop_validators.watchValidator(t,"_variant",(t=>"string"==typeof t&&buttonVariantPropTypeOptions.includes(t)),new Set([`KoliBriButtonVariant {${buttonVariantPropTypeOptions.join(", ")}`]),e,{defaultValue:"normal"})},KolButtonWc=class{async kolFocus(){var t;null===(t=this.buttonRef)||void 0===t||t.focus()}render(){var t,e;const a=reuse.showExpertSlot(this.state._label),i=Boolean(null===(e=null===(t=this.state._ariaDescription)||void 0===t?void 0:t.trim())||void 0===e?void 0:e.length);return index.h(index.Host,{key:"5516bef539eb9262e669fe92f72dc243d8920bd0",class:"kol-button-wc"},index.h("button",Object.assign({key:"1d3eb3a7720f306a3c186feedfd365bf5331c86c",ref:this.catchRef,accessKey:this.state._accessKey||void 0,"aria-controls":this.state._ariaControls,"aria-describedby":i?this.internalDescriptionById:void 0,"aria-expanded":prop_validators.mapBoolean2String(this.state._ariaExpanded),"aria-label":this.state._hideLabel&&"string"==typeof this.state._label?this.state._label:void 0,"aria-selected":prop_validators.mapStringOrBoolean2String(this.state._ariaSelected),class:{button:!0,disabled:!0===this.state._disabled,[this.state._variant]:"custom"!==this.state._variant,[this.state._customClass]:"custom"===this.state._variant&&"string"==typeof this.state._customClass&&this.state._customClass.length>0,"hide-label":!0===this.state._hideLabel},disabled:this.state._disabled,id:this.state._id,name:this.state._name},this.state._on,{onClick:this.onClick,role:this.state._role,tabIndex:this.state._tabIndex,type:this.state._type}),index.h(componentNames.KolSpanWcTag,{key:"3ba922687287ba66ce958e13b98802e62f333079",class:"button-inner",_accessKey:this.state._accessKey,_icons:this.state._icons,_hideLabel:this.state._hideLabel,_label:a?"":this.state._label},index.h("slot",{key:"9ee6d1239e3012f306e0b3ae8fc984db25225507",name:"expert",slot:"expert"}))),index.h(componentNames.KolTooltipWcTag,{key:"8ece133d5b3f4f3832e60e26b804c58244c8b364","aria-hidden":"true",hidden:a||!this.state._hideLabel,_accessKey:this._accessKey,_align:this.state._tooltipAlign,_label:"string"==typeof this.state._label?this.state._label:""}),i&&index.h("span",{key:"f2a460b10f336b17add6fd3663c0f4ceef91ddb5",class:"visually-hidden",id:this.internalDescriptionById},this.state._ariaDescription))}constructor(t){index.registerInstance(this,t),this.internalDescriptionById=dev_utils.nonce(),this.catchRef=t=>{this.buttonRef=t},this.onClick=t=>{var e,a;"submit"===this.state._type?controller.propagateSubmitEventToForm({form:this.host,ref:this.buttonRef}):"reset"===this.state._type?controller.propagateResetEventToForm({form:this.host,ref:this.buttonRef}):(events.stopPropagation(t),events.tryToDispatchKoliBriEvent("click",this.host,this.state._value),this.controller.setFormAssociatedValue(this.state._value),"function"==typeof(null===(e=this.state._on)||void 0===e?void 0:e.onClick)&&(prop_validators.setEventTarget(t,this.buttonRef),null===(a=this.state._on)||void 0===a||a.onClick(t,this.state._value)))},this._accessKey=void 0,this._ariaControls=void 0,this._ariaDescription=void 0,this._ariaExpanded=void 0,this._ariaSelected=void 0,this._customClass=void 0,this._disabled=!1,this._hideLabel=!1,this._icons=void 0,this._id=void 0,this._label=void 0,this._name=void 0,this._on=void 0,this._role=void 0,this._syncValueBySelector=void 0,this._tabIndex=void 0,this._tooltipAlign="top",this._type="button",this._value=void 0,this._variant="normal",this.state={_icons:{},_label:"",_on:{},_type:"button",_variant:"normal"},this.controller=new associated_controller.AssociatedInputController(this,"button",this.host)}validateAccessKey(t){accessKey.validateAccessKey(this,t)}validateAriaControls(t){validateAriaControls(this,t)}validateAriaDescription(t){ariaExpanded.validateAriaDescription(this,t)}validateAriaExpanded(t){ariaExpanded.validateAriaExpanded(this,t)}validateAriaSelected(t){validateAriaSelected(this,t)}validateCustomClass(t){customClass.validateCustomClass(this,t)}validateDisabled(t){disabled.validateDisabled(this,t)}validateHideLabel(t){hideLabel.validateHideLabel(this,t)}validateIcons(t){icons.validateIcons(this,t)}validateId(t){prop_validators.watchString(this,"_id",t)}validateLabel(t){label.validateLabelWithExpertSlot(this,t,{required:!0})}validateName(t){this.controller.validateName(t)}validateOn(t){validateButtonCallbacks(this,t)}validateRole(t){ariaExpanded.validateAlternativeButtonLinkRole(this,t)}validateSyncValueBySelector(t){this.controller.validateSyncValueBySelector(t)}validateTabIndex(t){tabIndex.validateTabIndex(this,t)}validateTooltipAlign(t){tooltipAlign.validateTooltipAlign(this,t)}validateType(t){validateButtonType(this,t)}validateValue(t){prop_validators.setState(this,"_value",t),this.controller.setFormAssociatedValue(this.state._value)}validateVariant(t){validateButtonVariant(this,t)}componentWillLoad(){this.validateAccessKey(this._accessKey),this.validateAriaControls(this._ariaControls),this.validateAriaDescription(this._ariaDescription),this.validateAriaExpanded(this._ariaExpanded),this.validateAriaSelected(this._ariaSelected),this.validateCustomClass(this._customClass),this.validateDisabled(this._disabled),this.validateHideLabel(this._hideLabel),this.validateIcons(this._icons),this.validateId(this._id),this.validateLabel(this._label),this.validateName(this._name),this.validateOn(this._on),this.validateRole(this._role),this.validateSyncValueBySelector(this._syncValueBySelector),this.validateTabIndex(this._tabIndex),this.validateTooltipAlign(this._tooltipAlign),this.validateType(this._type),this.validateValue(this._value),this.validateVariant(this._variant)}get host(){return index.getElement(this)}static get watchers(){return{_accessKey:["validateAccessKey"],_ariaControls:["validateAriaControls"],_ariaDescription:["validateAriaDescription"],_ariaExpanded:["validateAriaExpanded"],_ariaSelected:["validateAriaSelected"],_customClass:["validateCustomClass"],_disabled:["validateDisabled"],_hideLabel:["validateHideLabel"],_icons:["validateIcons"],_id:["validateId"],_label:["validateLabel"],_name:["validateName"],_on:["validateOn"],_role:["validateRole"],_syncValueBySelector:["validateSyncValueBySelector"],_tabIndex:["validateTabIndex"],_tooltipAlign:["validateTooltipAlign"],_type:["validateType"],_value:["validateValue"],_variant:["validateVariant"]}}};exports.kol_button_wc=KolButtonWc;